/*
+------------------
| ZINC Tokenizer (Tolkienizer)
|
| Christopher Bowron / DiGiTaL Dreamland 1996
|              l MCMXCVI
+------------------
*/
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <alloc.h>

/*#define DEBUGMEM*/

int tokencount;
/********************************************/
char * newtoken(void)
{
	char *t;
	t=malloc(128);
	if (t==NULL)
	{
		printf("zinc.exe : out of memory\n\n");
		exit(255);
	}
	strcpy(t,"");
	return t;
}
/********************************************/
char **addtoken(char **tokenarray, char *newtok)
{
	char **newarray;
	int i;

	if (!strcmp(newtok,"")) /* newtok is blank */
		return tokenarray;
#ifdef DEBUG
	printf("adding token : %s\n", newtok);
#endif
	newarray = malloc((tokencount+2)*sizeof(char *));

	if (newarray==NULL)
	{
		printf("zinc.exe : no memory\n\n");
		exit(255);
	}

	for (i=0;i<tokencount;i++)
	{
		newarray[i]=malloc(1+strlen(tokenarray[i]));
		strcpy(newarray[i],tokenarray[i]);
		free(tokenarray[i]);
	}

	newarray[tokencount]=malloc(1+strlen(newtok));
	strcpy(newarray[tokencount],newtok);

	tokencount++;
#ifdef DEBUG
	printf("added token : %s\n", newarray[tokencount-1]);

	printf("\tcurrent tokens : ");
	for (i=0;i<tokencount-1;i++)
		printf("%s ", newarray[i]);
	printf("\n");
#endif

	/*free (tokenarray);*/
	return newarray;
}
/********************************************/
char **split(char *l)
{
	char **tok;
	char **newtok;
	char *tmpstr;
	char *inittmp;

	int pos=0;
	int len;
	char *curtok;
#ifdef DEBUGMEM
	printf("split (begin) : free heap memory : %u\n", coreleft());
#endif
	tokencount=0;

	tmpstr=malloc(strlen(l)+1);
	inittmp=tmpstr;
	strcpy(tmpstr,l);

	while (*tmpstr==' '||*tmpstr=='\t'||*tmpstr=='\n') tmpstr++;

	curtok=newtoken();

	for (len=strlen(tmpstr);len>0;len--)
	{
		if (*tmpstr==0)
			break;

		switch(*tmpstr)
		{

		case '\n':
		case ' ' :
		case '\t':
			curtok[pos]=0;
			tok = addtoken(tok, curtok);
			pos=0;
			free(curtok);
			curtok=newtoken();
			break;

		case '(':
		case ')':
		case '{':
		case '}':
		case '>':
		case '<':
		case ']':
		case '[':
		case ',':
		case ';':
		case '=':
		case '+':
		case '-':
		case '*':
		case '/':
			curtok[pos]=0;
			tok = addtoken(tok, curtok);
			pos=0;
			free(curtok);
			curtok=newtoken();
			curtok[0]=*tmpstr;
			curtok[1]=0;
			tok = addtoken(tok, curtok);
			free(curtok);
			curtok=newtoken();
			break;

		case '"':
			curtok[pos]=0;
			pos=0;
			tok = addtoken(tok,curtok);
			free(curtok);
			curtok=newtoken();
			curtok[pos++]=*tmpstr;
			tmpstr++;
			while(*tmpstr!='"')
			{
				curtok[pos]=*tmpstr;
				len--;
				tmpstr++;
				pos++;
			}
			curtok[pos]='"';
			curtok[++pos]=0;
			tok = addtoken(tok, curtok);
			free(curtok);
			curtok=newtoken();
			break;

		default:
			curtok[pos]=*tmpstr;
			pos++;
			break;
		}
		tmpstr++;
	}
	free(curtok);
	tok[tokencount]=NULL;
	free(inittmp);
#ifdef DEBUGMEM
	printf("split (end) : free heap memory : %u\n", coreleft());
#endif
	return tok;
}
