#ifndef __ZINC_H
#define __ZINC_H

#define HL 		0
#define AF 		1
#define BC 		2
#define DE 		3
#define A 		4
#define B		5
#define C		6
#define D		7
#define E		8
#define F		9
#define I		10
#define IX		11
#define IY		12
#define PC		13
#define R		14
#define SP		15

#define VOID	16
#define CHAR 	17
#define INT 	18
#define POINTER 19

#define ZINCVER "8.30.96"


extern char **split(char *l);   /* defined in token.c */
extern char **parsefunction(char **tokens); /* parse.c */
extern void parse(char *l);
void die(char *s);
int isregister(char *s);
void addfunc(struct funcdef newfunc);
void addvar(struct variable v);
int lookupvar(char *v);
int lookupfunc(char *f);
int lookuptype(char *s); /* return place in array of vartypes */
char *z80typeof(char *s);
void addvar2func(struct funcdef *func, struct variable v);
int z80sizeof(char *st);

extern int tokencount;

extern char info[];
extern char datainfo[];
extern char *vartypes[];
struct variable
{
	int type;
	char *name;
};
struct funcdef
{
	int type;
	char *name;
	int vcount;
	struct variable *vars;
};

extern struct funcdef * funcs;
extern int funccount;

extern struct variable * variables;
extern int varcount;

extern unsigned int freemem; /* textmem in calculator... 168 bytes */
extern int varmem;                  /* running count of our variables         */

extern FILE *in, *out_asm, *out_dat;

extern int labelcount;
extern int opencount;
extern int linecount;
extern int datacount;
extern int outputsource;

extern int quietmode;
extern int verbosemode;


#endif